<template>
  <b-container fluid>
<b-button variant="primary" class="mb-2 mr-sm-2 mb-sm-2" @click="$router.go(-1)">Назад</b-button>
    <b-card :header="caption">
      <div slot="header">
        Отчеты детально
      </div>
      <download-excel
        class   = "btn btn-success pull-right mb-sm-2"
        :data   = "items"
        :fields = "jsonFields"
        name    = "filename.xls">

        Скачать Excel

      </download-excel>
      <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="date" slot-scope="data">
          <div v-if="data.item.date">
            {{ dateFormat(data.item.date) }}
          </div>
        </template>
        <template slot="cause" slot-scope="data">
          <div v-if="data.item.detailedCause">
            {{ data.item.cause + ", " + data.item.detailedCause }}
          </div>
          <div v-else>
            {{ data.item.cause }}
          </div>
        </template>
        <template slot="action" slot-scope="data">
          <b-button title="Редактировать" size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="items.length" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

    <b-modal id="modalInfo" title="Редактирование" centered @ok="edit" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Дата *</label>
          <datepicker :language="ru" v-model="modalInfo.date" name="date2" v-validate="'required'"></datepicker>
          <span v-show="errors.has('date2')" class="text-danger">{{ errors.first('date2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Коментарий *</label>
          <b-form-input type="text" name="comment" placeholder="Коментарий" v-model="modalInfo.comment" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('comment')" class="text-danger">{{ errors.first('comment') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Назначение *</label>
          <b-form-select type="text" name="cause" placeholder="Назначение" v-model="modalInfo.cause" :options="causes"  ></b-form-select>
          <span v-show="errors.has('cause')" class="text-danger">{{ errors.first('cause') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Детальное назначение</label>
          <b-form-input type="text" name="modalInfo.detailedCause" placeholder="Детальное назначение" v-model="modalInfo.detailedCause"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Расход *</label>
          <b-form-input type="text" name="modalInfo.outcome" placeholder="Детальное назначение" v-model="modalInfo.outcome" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('modalInfo.outcome')" class="text-danger">{{ errors.first('modalInfo.outcome') }}</span>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit()">Редактировать</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import { ru } from 'vuejs-datepicker/dist/locale'
import Api from '@/services/Api'
import Datepicker from 'vuejs-datepicker'

const MONTHS = [
  'январь',
  'февраль',
  'марта',
  'апрель',
  'май',
  'июнь',
  'июль',
  'август',
  'сентябрь',
  'октябрь',
  'ноябрь',
  'декабрь'
]

export default {
  name: 'ReportDetails',
  components: {
    Datepicker
  },
  props: {
    caption: {
      type: String,
      default: 'Отчеты'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      ru: ru,
      jsonFields: {
        'Дата' : 'date',
        'Контрагент' : 'contrAgent',
        'Назначение платежа' : 'cause',
        'Комментарий' : 'comment',
        'Приход' : 'summ',
        'Расход' : 'outcome'
      },
      items: [],
      causes: [],
      employees: [],
      data: '',
      type: 'ordinary',
      fields: [
        { key: 'date', sortable: true, label: 'Дата' },
        { key: 'contrAgent', sortable: true, label: 'Контрагент' },
        { key: 'cause', sortable: true, label: 'Назначение платежа' },
        { key: 'comment', sortable: true, label: 'Комментарий' },
        { key: 'summ', sortable: true, label: 'Приход' },
        { key: 'outcome', sortable: true, label: 'Расход' },
        { key: 'action', sortable: true, label: 'Редактировать' }
      ],
      currentPage: 1,
      perPage: 20,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      addedModal: {
        summ: '',
        comment: '',
        cause: '',
        detailedCause: '',
        employee: '',
        date: ''
      },
      modalInfo: {
        comment: '',
        cause: '',
        detailedCause: '',
        outcome: '',
      },
    }
  },
  beforeMount () {
    this._beforeMount()
    this.getEmployees()
    this.getArticles()
  },
  methods: {
    _beforeMount () {
      this.data = this.$route.query
      if (this.data.cause == 'Перевозка') {
        this.type = 'Перевозка'
        this.fields.pop()
        this.getBids()
      } else {
        this.getOutgoes()
      }
    },
    getOutgoes () {
      Api().post('getoutgoesByDate', { year: this.data.year, month: this.data.month, cause: this.data.cause }).then(response => {
        if (response.data instanceof Array)
        this.items = response.data.map(item => {
          return {
            _id: item._id,
            date: item.date,
            contrAgent: item.employee.name + ' ' + item.employee.lastName,
            cause: item.cause == 'present' ? 'Представитель' : item.cause,
            detailedCause: item.detailedCause,
            comment: item.comment == undefined ? '' : item.comment,
            summ: '',
            outcome: item.summ
          }
        })
      })
    },
    getBids () {
      Api().post('getbidsbydate', {year: this.data.year, month: this.data.month}).then(response => {
        this.items = response.data.map(item => {
          return {
            _id: item._id,
            date: item.date,
            contrAgent: item.contrAgent.name + ' ' + item.contrAgent.lastName,
            cause: 'Перевозка',
            comment: item.comment == undefined ? '' : item.comment,
            summ: item.summ,
            outcome: ''
          }
        })
      })
    },
    getEmployees () {
      Api().get('getEmployees').then(response => {
        this.employees = response.data.users.map(item => {
          return { value: item._id, text: item.name + ' ' + item.lastName }
        })
      })
    },
    getArticles () {
      Api().get('getcauses').then(response => {
        this.causes = response.data.causes.map(item => {
          return { value: item.name, text: item.name }
        })
        this.causes.push({value: 'present', text: 'Представителю'})
      })
    },
    adding () {
      Api().post('addOutgoes', this.addedModal).then(response => {
        this.resetModal()
        window.location.reload()
      })
    },
    edit () {
      if (this.validated()) {
        this.modalInfo.summ = this.modalInfo.outcome
        Api().post('editOutgo', this.modalInfo).then(response => {
          window.location.reload()
        })
      }
    },
    info (_item) {
      this.modalInfo = JSON.parse(JSON.stringify(_item))
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage = 1
    },
    validated () {
      return (this.modalInfo.comment.length > 0 && this.modalInfo.outcome > 0)
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    },
    dateFormat (_date) {
      function fmt (n) {
        return n > 9 ? n : '0' + n
      }
      const now = new Date(_date)
      const date = fmt(now.getDate()) + '.' + fmt(now.getMonth() + 1) + '.' + fmt(now.getFullYear())
      const time = fmt(now.getHours()) + ':' +  fmt(now.getMinutes())
      return date
    }
  }
}
</script>
